/**
 * Tocea Softwares.
 * <p>
 * 
 * @author $Author: sleroy $
 * @since 23 mai 2012
 * @copyright Copyright (C) 2010-2012 Tocea
 */

package com.tocea.easycoverage.framework;



import java.util.List;

import junit.framework.Test;
import junit.framework.TestResult;

import org.slf4j.LoggerFactory;

import com.tocea.easycoverage.framework.behaviour.api.IClassTest;
import com.tocea.easycoverage.framework.behaviour.api.ITestBehaviour;
import com.tocea.easycoverage.framework.utils.WeakImplementationException;



/**
 * This type describes the test suite for an object instance.
 * <p>
 * 
 * @author $Author: sleroy $
 * @since 23 mai 2012
 * @copyright Copyright (C) 2010-2012 TOCEA
 */

public class SuiteInstanceTest implements Test
{
    
    
    //
    // New logger.
    private static final org.slf4j.Logger LOGGER = LoggerFactory.getLogger(SuiteInstanceTest.class);
    
    private final List<ITestBehaviour>    testBehaviours;
    
    private final Object                  object;
    
    
    
    /**
     * Builds a test
     * 
     * @param _testBehaviours
     *            the behaviours
     */
    public SuiteInstanceTest(final List<ITestBehaviour> _testBehaviours, final Object object) {
    
    
        super();
        this.testBehaviours = _testBehaviours;
        this.object = object;
        
        
    }
    
    
    /**
     * (non-Javadoc)
     * 
     * @see junit.framework.Test#countTestCases()
     */
    public int countTestCases() {
    
    
        return 1;
    }
    
    
    /**
     * (non-Javadoc)
     * 
     * @see junit.framework.Test#run(junit.framework.TestResult)
     */
    public void run(final TestResult _result) {
    
    
        _result.startTest(this);
        
        try {
            this.testingInstanceObject();
        } catch (final WeakImplementationException e) {
            _result.addError(this, e);
        } finally {
            _result.endTest(this);
        }
    }
    
    
    /**
     * This method performs the test of an instance.
     * 
     * @param object
     *            the result of the test.
     */
    public boolean testingInstanceObject() throws WeakImplementationException {
    
    
        boolean res = false;
        LOGGER.info("\t[TEST] Object '{}' of {}", this.object, this.object.getClass());
        for (final ITestBehaviour testBehaviour : this.testBehaviours) {
            final IClassTest newInstanceTest = testBehaviour.newInstanceTest(this.object);
            if (newInstanceTest == null) {
                continue;
            }
            newInstanceTest.performTest();
            res = true;
            
        }
        return res;
        
    }
    
    
    @Override
    public String toString() {
    
    
        return "Test of the instance of " + this.object.getClass().getCanonicalName();
    }
}
